REM **************************************************************************************************
REM **************************************************************************************************
REM *********************RUTINA IMPRESION SPRITE DE nXn CON COLOR*************************************
REM **************************************************************************************************
REM **************************************************************************************************



REM IX+5  Y
REM IX+7  X
REM IX+9  LAR
REM IX+11 BAR
REM IX+13 DIRGRAFICO
REM IX+12
REM IX+15 CO


REM ENTRADA: Y X ->COORDENADAS \\ LAR ->LARGO DEL SPRITE(X) \\ BAJ ->BAJO DEL SPRITE(Y) \\DIRGRAFICO -> DIRECCION DE SPRITE GUARDADO POR SCANLINES \\ CO -> ATRIBUTO




SUB DIBnXn (Y AS UBYTE, X AS UBYTE, LAR AS UBYTE, BAJ AS UBYTE, DIRGRAFICO AS UINTEGER,CO AS UBYTE)




ASM

                  ; REM CALCULO DE LA DIRECCION DE MEMORIA DEL SCAN 0 PRIMER CARACTER DEL SPRITE EN HL

LD A,(IX+5)       ; TENIENDO EN CUENTA QUE EL VALOR "Y" ES 000 TT FFF SE TRATA DE EXTRAER TT Y FFF PARA SACAR LA FILA Y EL TERCIO EN HL  PARA DEJARLO EN 010TT000 FFF00000 COMO "HL"
AND $18           ; AND 00011000 -> SACO EL TERCIO 00 1 --- 01 2 --- 10 3
ADD A,$40         ; AADO 3 BITS SUPERIORES 010 TT 000.  A TIENE AHORA EL VALOR ALTO DE LA DIRECCIN "H"
LD H,A

LD A,(IX+5)       ; VOLVEMOS A CARGAR PARA CALCULAR LA PARTE BAJA
AND 7             ; AND 00000111 -> ME QUEDO CON LOS TRES BITS MAS BAJOS QUE IDENTIFICAN LA FILA DENTRO DEL TERCIO
RRCA
RRCA
RRCA              ;ROTO A LA DERECHA TRES VECES 00000FFF  PASA A FFF00000; YA EST A CON EL VALOR BAJO DE LA DIRECCIN "L"
LD L,A

LD A,(IX+7)       ; AHORA DEBO SUMAR LA COLUMNA X QUE ES LINEAL A "L" TENIENDO EN CUENTA QUE "X" 000 CCCC Y SACAR ASI FINALMENTE 010TTSSS FFFCCCCC COMO "HL" CON X E Y
ADD A,L
LD L,A            ; YA ESTA HL CON EL VALOR GUAY DEL PRIMER CARACTER


                  ;REM DIBUJAMOS EL SPRITE

LD D, (IX+13)
LD E, (IX+12)


LD B,(IX+11)       ; REM BUCLE DE N VUELTAS PARA CADA FILA
BUCLE0:            ; SON VARIOS BUCLES ANIDADOS
PUSH BC


LD B, 8            ; 8 scanlines -> 8 iteraciones
BUCLE1:
PUSH BC

LD A, (DE)         ; Tomamos el dato del sprite
LD (HL), A         ; Establecemos el valor en videomemoria

LD B,(IX+9)
DEC B

BUCLE2:
INC DE             ; Incrementamos puntero en sprite
INC HL             ; Incrementamos puntero en pantalla SI FUERA "INC H" PASA AL SEGUNDO SCAN LINE, SI PONGO HL PASA AL CARACTER DE AL LADO
LD A, (DE)         ; Tomamos el dato del sprite
LD (HL), A
DJNZ BUCLE2


INC DE

LD B,(IX+9)
DEC B

BUCLE3:
DEC HL
DJNZ BUCLE3

INC H

POP BC
DJNZ BUCLE1
                   ; REM MODIFICAMOS HL PARA QUE PASE AL CARACTER DE ABAJO

   LD A, L
   ADD A, 32
   LD L, A
   JR C, CARACTER_ABAJO4
   LD A, H
   SUB 8
   LD H, A


CARACTER_ABAJO4:

POP BC
DJNZ BUCLE0



                  ;REM AHORA LO COLOREAMOS

                  ; REM CALCULO DE LA DIRECCION DE MEMORIA PRIMER CARACTER DEL SPRITE EN HL PARA ATRIBUTOS

LD A,(IX+5)       ; NECESITAMOS LLEGAR A "H" 010110FF "L" FFFCCCCC DESDE 000FFFFF y 000CCCCC
RRCA
RRCA
RRCA
AND 3             ; TENEMOS "A" COMO 000000FF
ADD A,88          ; YA TENEMOS "A" COMO  010110FF
LD H,A            ; LO PASO A "H"


LD A,(IX+5)       ; VUELVO A CARGAR 000FFFFF
AND 7             ; ME QUEDO CON LAS TRES F QUE FALTAN
RRCA
RRCA
RRCA              ; LAS ROTO A SU POSICIN




ADD A,(IX+7)      ; SUMO COLUMNA "X"
LD L,A            ; YA EST HL EN 1 ATRIBUTO

                  ; REM COLOREAMOS
LD A,(IX+15)

LD B,(IX+11)
BUCLE4:
PUSH BC

LD (HL),A

LD B,(IX+9)
DEC B
BUCLE5:

INC HL
LD (HL),A

DJNZ BUCLE5

LD B,(IX+9)
DEC B
BUCLE6:

DEC HL

DJNZ BUCLE6


LD DE,32
ADD HL,DE

POP BC
DJNZ BUCLE4




END ASM


END SUB
